# Supported vanilla objects

These are all the objects that hvcc is able to parse.

Here is a list of [unsupported Pd objects](10.unsupported_vanilla_objects.md).

## Message Objects

```list
!=
%
&
&&
|
||
*
+
-
/
<
<<
<=
==
>
>=
>>
abs
atan
atan2
b
bang
bendin
bendout
bng
change
clip
cnv
cos
ctlin
ctlout
dbtopow
dbtorms
declare
del
delay
div
exp
else/knob
f
float
floatatom
ftom
hradio
hsl
i
inlet
int
line
loadbang
log
makenote
max
metro
min
midiin
midiout
midirealtimein
mod
moses
mtof
nbx
notein
noteout
outlet
pack
pgmin
pgmout
pd
pipe
poly
polytouchin
polytouchout
pow
powtodb
print
r
random
receive
rmstodb
route
s
sel
select
send
sin
spigot
sqrt
stripnote
swap
symbol
symbolatom
t
table
tabread
tabwrite
tan
tgl
timer
touchin
touchout
trigger
unpack
until
vradio
vsl
wrap
```

## Signal Objects

```list
*~
+~
-~
/~
abs~
adc~
bang~
biquad~
bp~
catch~
clip~
complex-mod~
cos~
cpole~
czero_rev~
czero~
dac~
dbtopow~
dbtorms~
delread~
delread4~
delwrite~
env~
exp~
ftom~
hilbert~
hip~
inlet~
line~
lop~
max~
min~
mtof~
noise~
osc~
outlet~
phasor~
powtodb~
pow~
q8_rsqrt~
q8_sqrt~
receive~
rmstodb~
rpole~
rsqrt~
rzero_rev~
rzero~
r~
samphold~
samplerate~
send~
sig~
snapshot~
sqrt~
s~
tabosc4~
tabplay~
tabread4~
tabread~
tabwrite~
throw~
vcf~
vd~
wrap~
```

## `-p` Search Paths

`hvcc` will iterate through various directories when resolving patch objects and abstractions. The `-p` or `--search_paths` argument can be used to add additional folders for `hvcc` to look in.

This can be handy when using a third-party patch library such as [heavylib](https://github.com/Wasted-Audio/heavylib).

```bash
hvcc ~/myProject/_main.pd -o ~/Desktop/somewhere/else/ -n mySynth -p ~/Workspace/Projects/Enzien/heavylib/ ~/Desktop/myLib/
```
